<?php

namespace App\Http\Resources\API;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class BimFileResource extends BaseResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request): array
    {
        $extraArr = json_decode_arr($this->extra);

        return [
            'id' => $this->id,
            'file_id' => $this->file_id,
            'bim_file_id' => $this->bim_file_id,
            'convert_status' => $this->convert_status,
            'lightweight_size' => $extraArr['achievementFileSize'] ?? 0,
            'data_version' => $extraArr['dataVersion'] ?? '',
            'software_type' => $extraArr['softwareType'] ?? ($extraArr['fileOwnership'] ?? ''),
            'preview_image' => empty($this->preview_path) ? null : Storage::url($this->preview_path) . '&imageMogr2/thumbnail/!50p'
        ];
    }
}
