<?php

namespace App\Models;
use App\Libraries\BIM\BIMDriverEnum;

class BimFile extends BaseModel
{
    public function file()
    {
        return $this->hasOne(File::class, 'id', 'file_id');
    }

    public function scopeModelType($query, array $modelTypeArr = [])
    {
        if (!empty($modelTypeArr)) {
            return $query->whereIn('model_type', $modelTypeArr);
        }
    }

    public function scopeGelendale($query)
    {
        return $query->where('bim_driver', BIMDriverEnum::GLENDALE->value);
    }

    public function scopeCreatedAtStart($query, string $dateTime = '')
    {
        if (!empty($dateTime)) {
            return $query->where('created_at', '>=', $dateTime);
        }
    }
}
